# quicksort in 124 bytes
# by pt@matfyz.cz

.text
# pt_qsort(base, nmemb, size, compare)
# saves all registers according to the contest rules
# expects compare to save ebx edi esi ebp (according to i386 abi)
.globl pt_qsort
.type	pt_qsort, @function
pt_qsort:
   pushal
   movl 48(%esp),%ebx  # compare
   movl 44(%esp),%ebp  # size
   movl 40(%esp),%eax  # nmemb
   movl 36(%esp),%esi  # base
   decl %eax           # nmemb - 1
   mull %ebp           # eax = (nmemb - 1)*size
   movl %esi,%edi
   addl %eax,%edi      # edi = last of base   
   call .Lqsort1       # params in regs 
   popal
.Lqsort0:
   ret

# (start in esi, end in edi) size in ebp; compare in ebx
.Lqsort1:
   cmpl %edi,%esi       # no items
   jae .Lqsort0
   pushl %edi           # save start
   pushl %esi           # save end
   movl %esi,%edx       # edx = pivot

   jmp .Lqsort2
.Lqsort3:   
   addl %ebp,%esi       # move ptr
.Lqsort2:
   pushl %edx
   pushl %edx
   pushl %esi
   call *%ebx           # compare
   testl %eax,%eax
   popl  %ecx
   popl  %ecx
   popl  %edx
   js .Lqsort3

   jmp .Lqsort5
.Lqsort4:
   subl %ebp,%edi       # move ptr
.Lqsort5:
   pushl %edx
   pushl %edi
   pushl %edx
   call *%ebx           # compare
   testl %eax,%eax
   popl  %ecx
   popl  %ecx
   popl  %edx
   js .Lqsort4

   cmpl %edi,%esi       # ptrs meet? 
   je .Lqsort9
   ja .Lqsort10

   cmpl %esi,%edx    # pivot change?
   jne .Lqsort6
   movl %edi,%edx    # update pivot
   jmp .Lqsort7

.Lqsort6:
   cmpl %edi,%edx    # pivot change?
   jne .Lqsort7
   movl %esi,%edx    # update pivot

.Lqsort7:
   mov %ebp,%ecx
.Lqsort8:
   movb (%esi),%al   # exchange values
   xchgb (%edi),%al
   movb %al,(%esi)
   incl %esi         # implicit ptr update
   incl %edi
   loop .Lqsort8

   subl %ebp,%edi    # update ptr
   subl %ebp,%edi
   jmp .Lqsort2

.Lqsort9:
   addl %ebp,%esi    # update for eql ptrs

.Lqsort10:

   popl %eax         # start (orig edi param)
   pushal
   movl %eax,%esi    # new start param
   # new end is already in edi
   call .Lqsort1
   popal

   popl %edi         # end (orig call edi)
   # new start is already in esi
   # tail recursion
   jmp .Lqsort1
.size	pt_qsort, .-pt_qsort

